<?php

namespace VerifoneEcomAPI\ApiWrapper;

use Configuration;

/**
 * Class Settings
 * @package VerifoneEcomAPI\ApiWrapper
 */
class Settings
{

    private $testMode;
    private $apiKey;
    private $userId;
    private $entityId;
    private $region;
    private $title;
    private $description;
    private $cardEnabled;
    private $paymentContractId;
    private $threeDSEnabled;
    private $threeDSContractId;
    private $curlVerifySSL;
    private $checkoutType;
    private $paypalEnabled;
    private $paypalContractId;
    private $themeId;
    private $applePayEnabled;
    private $applePaySCALevel;
    private $applePayContractId;
    private $applePayThreeDSContractId;

    private $googlePayEnabled;
    private $googlePaySCALevel;
    private $googlePayContractId;
    private $googlePayThreeDSContractId;

//    public $transactionType;


    public function __construct()
    {
        $this->testMode                   = Configuration::get('VERIFONE_MODE');
        $this->apiKey                     = Configuration::get('VERIFONE_API_KEY');
        $this->userId                     = Configuration::get('VERIFONE_USER_ID');
        $this->entityId                   = Configuration::get('VERIFONE_ENTITY_ID');
        $this->region                     = Configuration::get('VERIFONE_REGION');
        $this->title                      = Configuration::get('VERIFONE_TITLE');
        $this->description                = Configuration::get('VERIFONE_DESCRIPTION');
        $this->cardEnabled                = Configuration::get('VERIFONE_CARD_ENABLED');
        $this->paymentContractId          = Configuration::get('VERIFONE_PAYMENT_CONTRACT_ID');
        $this->threeDSEnabled             = Configuration::get('VERIFONE_3DS_ENABLED');
        $this->threeDSContractId          = Configuration::get('VERIFONE_3DS_CONTRACT_ID');
        $this->curlVerifySSL              = Configuration::get('VERIFONE_CURL_VERIFY_SSL');
        $this->checkoutType               = Configuration::get('VERIFONE_CHECKOUT_TYPE');
        $this->paypalEnabled              = Configuration::get('VERIFONE_PAYPAL_ENABLED');
        $this->paypalContractId           = Configuration::get('VERIFONE_PAYPAL_CONTRACT_ID');
        $this->themeId                    = Configuration::get('VERIFONE_THEME_ID');
        $this->applePayEnabled            = Configuration::get('VERIFONE_APPLE_PAY_ENABLED');
        $this->applePayContractId         = Configuration::get('VERIFONE_APPLE_PAY_CONTRACT_ID');
        $this->applePayThreeDSContractId  = Configuration::get('VERIFONE_APPLE_PAY_THREE_DS_CONTRACT_ID');
        $this->applePaySCALevel           = Configuration::get('VERIFONE_APPLE_PAY_SCA_LEVEL');
        $this->googlePayEnabled           = Configuration::get('VERIFONE_GOOGLE_PAY_ENABLED');
        $this->googlePayContractId        = Configuration::get('VERIFONE_GOOGLE_PAY_CONTRACT_ID');
        $this->googlePayThreeDSContractId = Configuration::get('VERIFONE_GOOGLE_PAY_THREE_DS_CONTRACT_ID');
        $this->googlePaySCALevel          = Configuration::get('VERIFONE_GOOGLE_PAY_SCA_LEVEL');
//        $this->transactionType   = Configuration::get('VERIFONE_TRANSACTION_TYPE');
    }

    /**
     * @return mixed
     */
    public function isTest()
    {
        return $this->testMode !== 'live';
    }

    /**
     * @return mixed
     */
    public function getApplePayEnabled()
    {
        return $this->applePayEnabled;
    }

    /**
     * @return mixed
     */
    public function getApplePaySCALevel()
    {
        return $this->applePaySCALevel;
    }

    /**
     * @return mixed
     */
    public function getApplePayContractId()
    {
        return $this->applePayContractId;
    }

    /**
     * @return mixed
     */
    public function getApplePayThreeDSContractId()
    {
        return $this->applePayThreeDSContractId;
    }


    /**
     * @return mixed
     */
    public function getGooglePayEnabled()
    {
        return $this->googlePayEnabled;
    }

    /**
     * @return mixed
     */
    public function getGooglePaySCALevel()
    {
        return $this->googlePaySCALevel;
    }

    /**
     * @return mixed
     */
    public function getGooglePayContractId()
    {
        return $this->googlePayContractId;
    }

    /**
     * @return mixed
     */
    public function getGooglePayThreeDSContractId()
    {
        return $this->googlePayThreeDSContractId;
    }

    /**
     * @return mixed
     */
    public function getApiKey()
    {
        return $this->apiKey;
    }

    /**
     * @return false|string
     */
    public function getUserId()
    {
        return $this->userId;
    }

    /**
     * @return mixed
     */
    public function getEntityId()
    {
        return $this->entityId;
    }

    /**
     * @return mixed
     */
    public function getRegion()
    {
        return $this->region;
    }

    /**
     * @return mixed
     */
    public function getTitle()
    {
        return $this->title;
    }

    /**
     * @return mixed
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * @return mixed
     */
    public function getCardEnabled()
    {
        return $this->cardEnabled;
    }

    /**
     * @return mixed
     */
    public function getPaymentContractId()
    {
        return $this->paymentContractId;
    }

    /**
     * @return mixed
     */
    public function getThreeDSEnabled()
    {
        return $this->threeDSEnabled;
    }

    /**
     * @return mixed
     */
    public function getThreeDSContractId()
    {
        return $this->threeDSContractId;
    }

    /**
     * @return mixed
     */
    public function getCurlVerifySSL()
    {
        return $this->curlVerifySSL;
    }

    /**
     * @return mixed
     */
    public function getCheckoutType()
    {
        return $this->checkoutType ==='hpp' ?'hpp': 'iframe';
    }

    /**
     * @return false|string
     */
    public function getPaypalEnabled()
    {
        return $this->paypalEnabled;
    }

    /**
     * @return false|string
     */
    public function getPaypalContractId()
    {
        return $this->paypalContractId;
    }

    /**
     * @return false|string
     */
    public function getThemeId()
    {
        return $this->themeId;
    }
//
//    /**
//     * @return false|string
//     */
//    public function getTransactionType()
//    {
//        return $this->transactionType;
//    }

}
