<?php

class Verifone_Helper
{

    private $mobile_detect;
    private $hasErrors = false;
    private $errorBag = [];

    public function __construct()
    {
        $this->mobile_detect  = new Mobile_Detect();
        $_SESSION['vf_flash'] = [];
    }

    public function getDeviceType()
    : string
    {
        $device_type = 'S';
        if ($this->mobile_detect->isMobile()) {
            $device_type = 'P';
        } elseif ($this->mobile_detect->isTablet()) {
            $device_type = 'T';
        }

        return $device_type;
    }

    /**
     * Check if a string is a valid UUID
     *
     * @param $key
     * @param $value
     *
     * @return void
     */
    public function uuid($key, $value)
    {

        if (strlen($value) &&
            ( ! is_string($value) ||
              preg_match('/^[0-9a-f]{8}-[0-9a-f]{4}-4[0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}$/', $value) !== 1)) {
            $this->hasErrors              = true;
            $this->errorBag[$key][] = 'You must provide a valid UUID value format!';
        }
    }

    public function required($key, $value)
    {
        if (empty($value)){
            $this->hasErrors          = true;
            $this->errorBag[$key][] = 'This field is required!';
        }
    }

    /**
     * @return bool
     */
    public function hasErrors()
    : bool
    {
        return $this->hasErrors;
    }

    /**
     * @return array
     */
    public function getErrorBag()
    : array
    {
        return $this->errorBag;
    }
}
